# MarkovGrams

Experiments into markov chains, n-grams, and text generation. This repository is the result of the markov chain blog post mini-series on my blog.

 - [Part 1 - n-grams](https://starbeamrainbowlabs.com/blog/article.php?article=posts/236-Markov-Chain-Part-1-N-Grams.html)
 - [Part 2 - unweighted markov chains](https://starbeamrainbowlabs.com/blog/article.php?article=posts%2F238-Markov-Chains-Part-2-Unweighted-Chains.html)

## Building
Building this project should be easy - I can provide prebuilt binaries upon request though if asked (see [my website](https://starbeamrainbowlabs.com/) for contact information).

### Windows
Open the solution in Visual Studio / MonoDevelop and hit build.

### Linux and everyone else
As above with MonoDevelop, or simply use the command `xbuild` whilst inside the root of the repository.


## Using
Detailed usage help can be seen by simply running the tool without any arguments:

```bash
./MarkovGrams.exe
```

Linux users might need to explicitly run it with `mono`:

```bash
mono ./MarkovGrams.exe
```

## Credits
 - The code was written by [Starbeamrainbowlabs](https://starbeamrainbowlabs.com/) - that's me!
 - I found the [Markov Chain Text Generation](http://nullprogram.com/blog/2012/09/05/) post by [Chris Wellons](http://nullprogram.com/) rather useful when writing this.
 - Wordlists
	 - The list of colours was built with a sneaky bit of Javascript in the developer tools of [this webpage](http://www.colorhexa.com/color-names) from [colorhexa](http://www.colorhexa.com/), which turns out to be a really useful website about colours.
	 - The list of sciencey words was built from scratch by [Starbeamrainbowlabs](https://starbeamrainbowlabs.com/) - that's me too!
